// LCView.cpp : implementation of the CLCView class
//   

#include "stdafx.h"
#include "LC.h"
#include "TOOLBOX.h"
#include "Start.h"
#include "MainFrm.h"
#include "LCDoc.h"
#include "LCView.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int BigCount;

// CLCView

IMPLEMENT_DYNCREATE(CLCView, CFormView)

BEGIN_MESSAGE_MAP(CLCView, CFormView)
	ON_WM_CONTEXTMENU()
	//{{AFX_MSG_MAP(CLCView)
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONUP()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_COMMAND(IDC_CALC, OnCalc)
	ON_COMMAND(ID_POPUP_EXIT, OnPopupExit)
	ON_WM_DESTROY()
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLCView construction/destruction

CLCView::CLCView()
	: CFormView(CLCView::IDD)
{
	//{{AFX_DATA_INIT(CLCView)
	//}}AFX_DATA_INIT
	// TODO: add construction code here
}

CLCView::~CLCView()
{
}

void CLCView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLCView)
	//}}AFX_DATA_MAP
}

BOOL CLCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// Open ToolBox Form in modless 
	m_dToolBox.Create(IDD_TOOLBOX,NULL);
	return CFormView::PreCreateWindow(cs);
}

void CLCView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
	lhCursor=AfxGetApp()->LoadCursor(IDC_NORMAL);
	SetCursor(lhCursor);
	Initialer();
	CRect rect,rect2;
	GetClientRect(&rect);
	ClientToScreen(&rect);
	CPoint point;
	point = rect.TopLeft();
	m_dToolBox.GetClientRect(&rect);
	int x =rect.Width();
	int y =rect.Height()+8;
	m_dToolBox.MoveWindow(point.x+1,point.y,x,y,TRUE);
	m_dToolBox.CheckDlgButton(IDC_RFAST,1);
}

/////////////////////////////////////////////////////////////////////////////
//////////// Call Sequences : Draw->Grid->Snaper->ShowBitmap ////////////////
/////////////////////////////////////////////////////////////////////////////

BOOL CLCView::OnPreparePrinting(CPrintInfo* pInfo)
{
	return DoPreparePrinting(pInfo);
}

void CLCView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CLCView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CLCView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
}

// CLCView diagnostics

#ifdef _DEBUG
void CLCView::AssertValid() const
{
	CFormView::AssertValid();
}

void CLCView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CLCDoc* CLCView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CLCDoc)));
	return (CLCDoc*)m_pDocument;
}
#endif //_DEBUG

// CLCView message handlers

void CLCView::OnPopupExit() 
{
}

BOOL CLCView::DestroyWindow() 
{
	return CFormView::DestroyWindow();
}

void CLCView::OnDestroy() 
{
	CFormView::OnDestroy();
}

BOOL CLCView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	m_pViewWnd=pWnd;
	
	switch (m_dToolBox.CursorValue){
	case AND:  
		lhCursor=AfxGetApp()->LoadCursor(IDC_AND);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case NAND:
		lhCursor=AfxGetApp()->LoadCursor(IDC_NAND);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case OR:
		lhCursor=AfxGetApp()->LoadCursor(IDC_OR);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case NOR:
		lhCursor=AfxGetApp()->LoadCursor(IDC_NOR);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case NOT:
		lhCursor=AfxGetApp()->LoadCursor(IDC_NOT);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case XOR:
		lhCursor=AfxGetApp()->LoadCursor(IDC_XOR);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case XNOR:
		lhCursor=AfxGetApp()->LoadCursor(IDC_XNOR);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case DR:
		lhCursor=AfxGetApp()->LoadCursor(IDC_DR);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case DL:
		lhCursor=AfxGetApp()->LoadCursor(IDC_DL);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case UR:
		lhCursor=AfxGetApp()->LoadCursor(IDC_UR);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case UL:
		lhCursor=AfxGetApp()->LoadCursor(IDC_UL);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case UD:
		lhCursor=AfxGetApp()->LoadCursor(IDC_UD);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case DLR:
		lhCursor=AfxGetApp()->LoadCursor(IDC_DLR);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case SLR:
		lhCursor=AfxGetApp()->LoadCursor(IDC_SLR);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case _1TO2LR:
		lhCursor=AfxGetApp()->LoadCursor(IDC_1TO2LR);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;
	
	case _DEL:
		lhCursor=AfxGetApp()->LoadCursor(IDC_DEL);
		SetCursor(lhCursor);
		ShowFlag=FALSE;
		break;

	case START:
		lhCursor=AfxGetApp()->LoadCursor(IDC_START);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case END:
		lhCursor=AfxGetApp()->LoadCursor(IDC_END);
		SetCursor(lhCursor);
		ShowFlag=TRUE;
		break;

	case RLS:
		lhCursor=AfxGetApp()->LoadCursor(IDC_NORMAL);
		SetCursor(lhCursor);
		ShowFlag=FALSE;
		break;

	default :
		lhCursor=AfxGetApp()->LoadCursor(IDC_NORMAL);
		SetCursor(lhCursor);
		ShowFlag=FALSE;
		break;
	}
	return TRUE;
}

BOOL CLCView::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	return CFormView::OnNotify(wParam, lParam, pResult);
}

void CLCView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	CLCView * pWnd=(CLCView*)GetParent();
}

void CLCView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	Snaper(point.x,point.y,m_dToolBox.CursorValue);
	CFormView::OnLButtonDown(nFlags, point);
}


CLCView::Bk()
{
	Draw();
}

void CLCView::Draw()
{
	
}

boolean CLCView::Grid()
{
	return true;
}

CLCView::Draw2(CPaintDC pdc)
{
	CClientDC dc(this);
	BITMAP bm;
	CDC dcMemory;
	CBitmap bitmap;

	bitmap.LoadBitmap(IDB_BITMAP2);		
	bitmap.GetObject(sizeof(BITMAP),&bm);
	dcMemory.CreateCompatibleDC(&dc);
	dcMemory.SelectObject(&bitmap);
	dc.BitBlt(0,0,bm.bmWidth*32,bm.bmHeight*24,&dcMemory,0,0,LR_LOADTRANSPARENT);
}

void CLCView::ShowBitmap(int x,int y,int kind)
{
	CDocument* pDoc = GetDocument();
	CClientDC dc(this);
	CBitmap bitmap;
	CDC dcMemory;
	BITMAP bm;
	
	switch (kind) {
	case AND  : 
		bitmap.LoadMappedBitmap(IDB_AND,0);
		break;

	case NAND : 
		bitmap.LoadMappedBitmap(IDB_NAND,0);
		break;

	case OR   : 
		bitmap.LoadMappedBitmap(IDB_OR,0);
		break;

	case NOR  : 
		bitmap.LoadMappedBitmap(IDB_NOR,0);
		break;

	case NOT  : 
		bitmap.LoadMappedBitmap(IDB_NOT,0);
		break;

	case XOR  : 
		bitmap.LoadMappedBitmap(IDB_XOR,0);
		break;

	case XNOR : 
		bitmap.LoadMappedBitmap(IDB_XNOR,0);
		break;

	case DLR   : 
		bitmap.LoadMappedBitmap(IDB_DLR,0);
		break;

	case SLR   : 
		bitmap.LoadMappedBitmap(IDB_SLR,0);
		break;
	
	case _1TO2LR   : 
		bitmap.LoadMappedBitmap(IDB_1TO2LR,0);
		break;

	case UD   : 
		bitmap.LoadMappedBitmap(IDB_UD,0);
		break;

	case UL   : 
		bitmap.LoadMappedBitmap(IDB_UL,0);
		break;

	case UR   : 
		bitmap.LoadMappedBitmap(IDB_UR,0);
		break;

	case DL   : 
		bitmap.LoadMappedBitmap(IDB_DL,0);
		break;

	case DR   : 
		bitmap.LoadMappedBitmap(IDB_DR,0);
		break;

	case _DEL   : 
		bitmap.LoadMappedBitmap(IDB_EMPTY,0);
		break;

	case START   : 
		if(kind==START)
			m_dStart.DoModal();
		
		if (m_dStart.StartValue==0)
			bitmap.LoadMappedBitmap(IDB_START0,0);
		else
			bitmap.LoadMappedBitmap(IDB_START1,0);
		//UpdateData(FALSE);
	
		break;

	case END   : 
		bitmap.LoadMappedBitmap(IDB_END,0);
		break;

	default   : break;
	}

	bitmap.GetObject(sizeof(BITMAP),&bm);
	dcMemory.CreateCompatibleDC(&dc);
	dcMemory.SelectObject(&bitmap);
	dc.BitBlt(x,y,bm.bmWidth,bm.bmHeight,&dcMemory,0,0,SRCCOPY);
}

void CLCView::OnCalc() 
{
	m_dToolBox.UpdateData(TRUE);
	
	if (m_dToolBox.m_rOption==0)
		FastTrace=TRUE;		
	else
		FastTrace=FALSE;		

	m_dToolBox.UpdateData(FALSE);
	
	Calc();
}

boolean CLCView::Snaper(int x, int y,int kind)
{
	x=(x/32)*32;
	y=(y/32)*32;
	
	if(ShowFlag==TRUE)
	{
		ShowBitmap(x,y,m_dToolBox.CursorValue);
		ScreenMap(x,y,m_dToolBox.CursorValue);
	}
	else
	if (kind==_DEL)
	{
		ShowBitmap(x,y,m_dToolBox.CursorValue);
		ScreenMap(x,y,m_dToolBox.CursorValue);
	}
	
	return true;
}

boolean CLCView::ScreenMap(int x, int y,int kind)
{
	int xMem,yMem;
	
	xMem=x/32;
	yMem=y/32;

	switch (kind) {
	case AND  : 
		screen[xMem][yMem].Gate=AND;
		screen[xMem][yMem].SGate="AND";
		screen[xMem][yMem].Group=1;
		screen[xMem][yMem].lunched=1;
		break;

	case NAND : 
		screen[xMem][yMem].Gate=NAND;
		screen[xMem][yMem].SGate="NAND";
		screen[xMem][yMem].Group=1;
		screen[xMem][yMem].lunched=1;
		break;

	case OR   : 
		screen[xMem][yMem].Gate=OR;
		screen[xMem][yMem].SGate="OR";
		screen[xMem][yMem].Group=1;
		screen[xMem][yMem].lunched=1;
		break;

	case NOR  : 
		screen[xMem][yMem].Gate=NOR;
		screen[xMem][yMem].SGate="NOR";
		screen[xMem][yMem].Group=1;
		screen[xMem][yMem].lunched=1;
		break;

	case NOT  : 
		screen[xMem][yMem].Gate=NOT;
		screen[xMem][yMem].SGate="NOT";
		screen[xMem][yMem].Group=1;
		screen[xMem][yMem].lunched=1;
		break;

	case XOR  : 
		screen[xMem][yMem].Gate=XOR;
		screen[xMem][yMem].SGate="XOR";
		screen[xMem][yMem].Group=1;
		screen[xMem][yMem].lunched=1;
		break;

	case XNOR : 
		screen[xMem][yMem].Gate=XNOR;
		screen[xMem][yMem].SGate="XNOR";
		screen[xMem][yMem].Group=1;
		screen[xMem][yMem].lunched=1;
		break;

	case DLR   : 
		screen[xMem][yMem].Gate=DLR;
		screen[xMem][yMem].SGate="DLR";
		screen[xMem][yMem].Group=2;
		screen[xMem][yMem].lunched=1;
		break;

	case SLR   : 
		screen[xMem][yMem].Gate=SLR;
		screen[xMem][yMem].SGate="SLR";
		screen[xMem][yMem].Group=2;
		screen[xMem][yMem].lunched=1;
		break;

	case _1TO2LR   : 
		screen[xMem][yMem].Gate=_1TO2LR;
		screen[xMem][yMem].SGate="_1TO2LR";
		screen[xMem][yMem].Group=2;
		screen[xMem][yMem].lunched=1;
		break;

	case UD   : 
		screen[xMem][yMem].Gate=UD;
		screen[xMem][yMem].SGate="UD";
		screen[xMem][yMem].Group=2;
		screen[xMem][yMem].lunched=1;
		break;

	case UL   : 
		screen[xMem][yMem].Gate=UL;
		screen[xMem][yMem].SGate="UL";
		screen[xMem][yMem].Group=2;
		screen[xMem][yMem].lunched=1;
		break;

	case UR   : 
		screen[xMem][yMem].Gate=UR;
		screen[xMem][yMem].SGate="UR";
		screen[xMem][yMem].Group=2;
		screen[xMem][yMem].lunched=1;
		break;

	case DL   : 
		screen[xMem][yMem].Gate=DL;
		screen[xMem][yMem].SGate="DL";
		screen[xMem][yMem].Group=2;
		screen[xMem][yMem].lunched=1;
		break;

	case DR   : 
		screen[xMem][yMem].Gate=DR;
		screen[xMem][yMem].SGate="DR";
		screen[xMem][yMem].Group=2;
		screen[xMem][yMem].lunched=1;
		break;

	case _DEL: 
		screen[xMem][yMem].lunched=0;
		screen[xMem][yMem].Gate=_DEL;
		screen[xMem][yMem].Group=0;
		
		break;

	case START: 
		screen[xMem][yMem].Gate=START;
		screen[xMem][yMem].SGate="START";
		screen[xMem][yMem].Group=2;
		screen[xMem][yMem].lunched=1;
		//m_dStart.UpdateData(TRUE);
		if (m_dStart.StartValue==0)
		{
			screen[xMem][yMem].inValue1=screen[xMem][yMem].inValue2=off;
			screen[xMem][yMem].outValue1=screen[xMem][yMem].outValue2=off;
		}
		else
		{
			screen[xMem][yMem].inValue1=screen[xMem][yMem].inValue2=on;
			screen[xMem][yMem].outValue1=screen[xMem][yMem].outValue2=on;
		}
		break;

	case END  : 
		screen[xMem][yMem].Gate=END;
		screen[xMem][yMem].SGate="END";
		screen[xMem][yMem].Group=1;
		screen[xMem][yMem].lunched=1;
		break;

	default   : break;
	}

	return true;
}

void CLCView::Calc()
{
	for (int i=0;i<32;i++)
		for (int j=0;j<24;j++)
			if (screen[i][j].lunched==1)
			{
				
				UpdateData(FALSE);

				switch (screen[i][j].Gate)
				{
				case AND :
					{
					switch (screen[i-1][j].Gate) 
					{
					case DLR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					case _1TO2LR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					default :
						MessageBox("There was must be a node before AND but there isn`t");
						break;
					}
					if ((screen[i][j].inValue1==1) && (screen[i][j].inValue2==1))
						screen[i][j].outValue1=screen[i][j].outValue2=on;
					else
						screen[i][j].outValue1=screen[i][j].outValue2=off;
					break;
					}

				case NAND:
					{
					switch (screen[i-1][j].Gate) 
					{
					case DLR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					case _1TO2LR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					default :
						MessageBox("There was must be a node before NAND but there isn`t");
						break;
					}
					if ((screen[i][j].inValue1==1) && (screen[i][j].inValue2==1))
						screen[i][j].outValue1=screen[i][j].outValue2=off;
					else
						screen[i][j].outValue1=screen[i][j].outValue2=on;
					break;
					}
								

				case OR:
					{
					switch (screen[i-1][j].Gate) 
					{
					case DLR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					case _1TO2LR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					default :
						MessageBox("There was must be a node before OR but there isn`t");
						break;
					}
					if ((screen[i][j].inValue1==0) && (screen[i][j].inValue2==0))
						screen[i][j].outValue1=screen[i][j].outValue2=off;
					else
						screen[i][j].outValue1=screen[i][j].outValue2=on;
					break;
					}

				case NOR:
					{
					switch (screen[i-1][j].Gate) 
					{
					case DLR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					case _1TO2LR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					default :
						MessageBox("There was must be a node before NOR but there isn`t");
						break;
					}
					if ((screen[i][j].inValue1==0) && (screen[i][j].inValue2==0))
						screen[i][j].outValue1=screen[i][j].outValue2=on;
					else
						screen[i][j].outValue1=screen[i][j].outValue2=off;
					break;
					}

				case XOR :
					{
					switch (screen[i-1][j].Gate) 
					{
					case DLR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					case _1TO2LR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					default :
						MessageBox("There was must be a node before XOR but there isn`t");
						break;
					}
					if ((screen[i][j].inValue1==1) && (screen[i][j].inValue2==1))
						screen[i][j].outValue1=screen[i][j].outValue2=off;
					else
						if ((screen[i][j].inValue1==0) && (screen[i][j].inValue2==0))
							screen[i][j].outValue1=screen[i][j].outValue2=off;
						else
							screen[i][j].outValue1=screen[i][j].outValue2=on;
					break;
					}

				case XNOR :
					{
					switch (screen[i-1][j].Gate) 
					{
					case DLR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					case _1TO2LR :
						screen[i][j].inValue1=screen[i-1][j].outValue1;
						screen[i][j].inValue2=screen[i-1][j].outValue2;
						break;
					default :
						MessageBox("There was must be a node before XNOR but there isn`t");
						break;
					}
					if ((screen[i][j].inValue1==1) && (screen[i][j].inValue2==1))
						screen[i][j].outValue1=screen[i][j].outValue2=off;
					else
						if ((screen[i][j].inValue1==0) && (screen[i][j].inValue2==0))
							screen[i][j].outValue1=screen[i][j].outValue2=on;
						else
							screen[i][j].outValue1=screen[i][j].outValue2=off;
					break;
					}

				case NOT :
					{
					switch (screen[i-1][j].Gate) 
					{
					case AND :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NAND:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case OR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOT :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XNOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case UR:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case DR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case SLR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case START:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					default :
						MessageBox("There was must be a node before NOT but there isn`t");
						break;
					}
					if (screen[i][j].inValue1==0)
						screen[i][j].outValue1=screen[i][j].outValue2=on;
					else
						screen[i][j].outValue1=screen[i][j].outValue2=off;
					
					break;
					}

					case DL :
					{
					switch (screen[i-1][j].Gate) 
					{
					case AND :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NAND:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case OR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOT :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XNOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case UR:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case DR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case SLR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case START:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					default :
						MessageBox("There was must be a node before DL but there isn`t");
						break;
					}
					screen[i][j].outValue1=screen[i][j].outValue2=screen[i][j].inValue1;
					break;
					}

					case UL :
					{
					switch (screen[i-1][j].Gate) 
					{
					case AND :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NAND:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case OR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOT :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XNOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case UR:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case DR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case SLR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case START:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					default :
						MessageBox("There was must be a node before UL but there isn`t");
						break;
					}
					screen[i][j].outValue1=screen[i][j].outValue2=screen[i][j].inValue1;
					break;
					}

					case SLR :
					{
					switch (screen[i-1][j].Gate) 
					{
					case AND :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NAND:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case OR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOT :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XNOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case UR:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case DR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case SLR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case START:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					default :
						MessageBox("There was must be a node before SLR but there isn`t");
						break;
					}
					screen[i][j].outValue1=screen[i][j].outValue2=screen[i][j].inValue1;
					break;
					}

					case _1TO2LR :
					{
					switch (screen[i-1][j].Gate) 
					{
					case AND :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NAND:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case OR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOT :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XNOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case UR:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case DR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case SLR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case START:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					default :
						MessageBox("There was must be a node before 1TO2 but there isn`t");
						break;
					}
					screen[i][j].outValue1=screen[i][j].outValue2=screen[i][j].inValue1;
					break;
					}

					case DR :
					{
					switch (screen[i][j+1].Gate) 
					{
					case UL :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i][j+1].outValue1;
						break;
					case UD:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i][j+1].outValue1;
						break;
					default :
						MessageBox("There was must be a node before DR but there isn`t");
						break;
					}
					screen[i][j].outValue1=screen[i][j].outValue2=screen[i][j].inValue1;
					break;
					}
					
					case UR :
					{
					switch (screen[i][j-1].Gate) 
					{
					case DL :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i][j-1].outValue1;
						break;
					case UD:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i][j-1].outValue1;
						break;
					default :
						MessageBox("There was must be a node before UR but there isn`t");
						break;
					}
					screen[i][j].outValue1=screen[i][j].outValue2=screen[i][j].inValue1;
					break;
					}
					
					case UD:
					{
					switch (screen[i][j-1].Gate)
					{
					case DL :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i][j-1].outValue1;
						break;
					case UD:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i][j-1].outValue1;
						break;
					default :
						MessageBox("There was must be a node before UD but there isn`t");
						break;
					}
					}

					case END :
					{
					switch (screen[i-1][j].Gate) 
					{
					case AND :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NAND:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case OR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case NOT :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case XNOR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case UR:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case DR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case SLR :
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					case START:
						screen[i][j].inValue1=screen[i][j].inValue2=screen[i-1][j].outValue1;
						break;
					default :
						MessageBox("There was must be a node before END but there isn`t");
						break;
					}
					screen[i][j].outValue1=screen[i][j].outValue2=screen[i][j].inValue1;
					break;
					}

					case DLR :
					{
					switch (screen[i][j-1].Gate) 
					{
					case DL :
						screen[i][j].inValue1=screen[i][j-1].outValue1;
						break;
					default :
						MessageBox("There was must be a node before DLR but there isn`t");
						break;
					}
					switch (screen[i][j+1].Gate) 
					{
					case UL :
						screen[i][j+1].inValue1=screen[i-1][j+1].outValue1;
						screen[i][j+1].outValue1=screen[i][j+1].inValue1;
						screen[i][j].inValue2=screen[i][j+1].outValue1;
						break;
					default :
						MessageBox("There was must be a node before UL but there isn`t");
						break;
					}

					screen[i][j].outValue1=screen[i][j].inValue1;
					screen[i][j].outValue2=screen[i][j].inValue2;
					break;
					}

					case START :
 						break;
					}
				
					m_dToolBox.m_EOX2=state(screen[i][j].inValue1);
					m_dToolBox.m_EOY2=state(screen[i][j].inValue2);
					m_dToolBox.m_EX2=state(screen[i][j].outValue1);
									
					if (screen[i][j].Group==1)
					{
						m_dToolBox.m_EGate2=screen[i][j].SGate;
						if(!FastTrace)
						{
							if(screen[i][j].Gate==END)
							{
								if (screen[i][j].outValue1==on)
									MessageBox("Finall Result : ON");
								else
									MessageBox("Finall Result : OFF");
							}
							else
								MessageBox("Peoceed To Next Gate ?!");

						}
						else
							if(screen[i][j].Gate==END)
								if (screen[i][j].outValue1==on)
									MessageBox("Finall Result : ON");
								else
									MessageBox("Finall Result : OFF");
					
					m_dToolBox.UpdateData(FALSE);
					}
					
			}
}	

void CLCView::Redrawer()
{


	BITMAP bm;

	CDC dcMemory2;
	CBitmap bitmap2;
	CClientDC dc2(this);
	

	for (int i=0;i<32;i++)
		for (int j=0;j<24;j++)
			if (screen[i][j].lunched==1)
			{
					
				switch (screen[i][j].Gate) {
				case AND  : 
					bitmap2.LoadMappedBitmap(IDB_AND,0);
					break;

				case NAND : 
					bitmap2.LoadMappedBitmap(IDB_NAND,0);
					break;

				case OR   : 
					bitmap2.LoadMappedBitmap(IDB_OR,0);
					break;

				case NOR  : 
					bitmap2.LoadMappedBitmap(IDB_NOR,0);
					break;
	
				case NOT  : 
					bitmap2.LoadMappedBitmap(IDB_NOT,0);
					break;
	
				case XOR  : 
					bitmap2.LoadMappedBitmap(IDB_XOR,0);
					break;

				case XNOR : 
					bitmap2.LoadMappedBitmap(IDB_XNOR,0);
					break;
	
				case DLR   : 
					bitmap2.LoadMappedBitmap(IDB_DLR,0);
					break;

				case SLR   : 
					bitmap2.LoadMappedBitmap(IDB_SLR,0);
					break;
	
				case _1TO2LR   : 
					bitmap2.LoadMappedBitmap(IDB_1TO2LR,0);
					break;

				case UD   : 
					bitmap2.LoadMappedBitmap(IDB_UD,0);
					break;

				case UL   : 
					bitmap2.LoadMappedBitmap(IDB_UL,0);
					break;

				case UR   : 
					bitmap2.LoadMappedBitmap(IDB_UR,0);
					break;

				case DL   : 
					bitmap2.LoadMappedBitmap(IDB_DL,0);
					break;

				case DR   : 
					bitmap2.LoadMappedBitmap(IDB_DR,0);
					break;

				case START   : 
					bitmap2.LoadMappedBitmap(IDB_START1,0);
					break;

				case END   : 
					bitmap2.LoadMappedBitmap(IDB_END,0);
					break;
				default   : break;
	}
	bitmap2.GetObject(sizeof(BITMAP),&bm);
	dcMemory2.CreateCompatibleDC(&dc2);
	dcMemory2.SelectObject(&bitmap2);
	dc2.BitBlt(i*32,j*32,bm.bmWidth,bm.bmHeight,&dcMemory2,0,0,SRCCOPY);
	}
}

void CLCView::Initialer()
{
	for (int i=0;i<32;i++)
		for (int j=0;j<24;j++)
			screen[i][j].lunched=0;
}

void CLCView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CFormView::OnLButtonDown(nFlags, point);
}


void CLCView::OnDraw(CDC* pDC) 
{
}


void CLCView::sb(CDC *pDC,int x,int y,int kind)
{

}

void CLCView::OnRButtonUp(UINT nFlags, CPoint point) 
{
		{
		if (point.x == -1 && point.y == -1){
			CRect rect;
			GetClientRect(rect);
			ClientToScreen(rect);

			point = rect.TopLeft();
			point.Offset(5, 5);
		}

		CMenu menu;
		VERIFY(menu.LoadMenu(CG_IDR_POPUP_LCVIEW));

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);
		CWnd* pWndPopupOwner = this;

		while (pWndPopupOwner->GetStyle() & WS_CHILD)
			pWndPopupOwner = pWndPopupOwner->GetParent();

		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y+70,
			pWndPopupOwner);
	}
}

void CLCView::OnContextMenu(CWnd*, CPoint point)
{
	{
		if (point.x == -1 && point.y == -1){
			CRect rect;
			GetClientRect(rect);
			ClientToScreen(rect);

			point = rect.TopLeft();
			point.Offset(5, 5);
		}

		CMenu menu;
		VERIFY(menu.LoadMenu(CG_IDR_POPUP_LCVIEW));

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);
		CWnd* pWndPopupOwner = this;

		while (pWndPopupOwner->GetStyle() & WS_CHILD)
			pWndPopupOwner = pWndPopupOwner->GetParent();

		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
			pWndPopupOwner);
	}
}

int CLCView::state(_state st)
{
		if (st==0)
			return 0;
		else
			return 1;

		if (st==0)
			return 0;
		else
			return 1;

		if (st==0)
			return 0;
		else
			return 1;

		if (st==0)
			return 0;
		else
			return 1;
}

void CLCView::OnFileNew() 
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
 	CFormView::ResizeParentToFit();	
}

void CLCView::OnFileSave() 
{
}
